unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ToolWin, Menus, ImgList, ActiveX, StdCtrls, OleCtrls, SHDocVw;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Arquivo1: TMenuItem;
    menuAbrir: TMenuItem;
    N1: TMenuItem;
    menuImprimir: TMenuItem;
    N2: TMenuItem;
    menuSair: TMenuItem;
    ToolBar1: TToolBar;
    BtHome: TToolButton;
    BtImprimir: TToolButton;
    BtAtualizar: TToolButton;
    ToolButton4: TToolButton;
    StatusBar1: TStatusBar;
    ImageList1: TImageList;
    BtAbrir: TToolButton;
    BtVoltar: TToolButton;
    BtAvancar: TToolButton;
    Edit1: TEdit;
    BtSep1: TToolButton;
    BtSep2: TToolButton;
    WebBrowser1: TWebBrowser;
    OpenDialog1: TOpenDialog;
    menuSalvarComo: TMenuItem;
    SaveDialog1: TSaveDialog;
    BtSalvarComo: TToolButton;
    procedure FormCreate(Sender: TObject);
    procedure WebBrowser1DownloadBegin(Sender: TObject);
    procedure WebBrowser1NavigateComplete2(Sender: TObject;
      const pDisp: IDispatch; var URL: OleVariant);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure BtAtualizarClick(Sender: TObject);
    procedure BtVoltarClick(Sender: TObject);
    procedure BtAvancarClick(Sender: TObject);
    procedure BtHomeClick(Sender: TObject);
    procedure WebBrowser1DownloadComplete(Sender: TObject);
    procedure menuAbrirClick(Sender: TObject);
    procedure BtAbrirClick(Sender: TObject);
    procedure menuSairClick(Sender: TObject);
    procedure menuImprimirClick(Sender: TObject);
    procedure BtImprimirClick(Sender: TObject);
    procedure menuSalvarComoClick(Sender: TObject);
    procedure BtSalvarComoClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
 WebBrowser1.Anchors := [akLeft,akRight,akTop,akBottom];
end;

procedure TForm1.WebBrowser1DownloadBegin(Sender: TObject);
begin
 StatusBar1.SimpleText := 'Carregando ...';
end;

procedure TForm1.WebBrowser1NavigateComplete2(Sender: TObject;
  const pDisp: IDispatch; var URL: OleVariant);
begin
 StatusBar1.SimpleText := 'Concludo';
 Edit1.Text := WebBrowser1.LocationURL;
 Caption := WebBrowser1.LocationURL + ' - ' + Application.Title ;
end;

procedure TForm1.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if Key = VK_RETURN then
  WebBrowser1.Navigate(Edit1.Text);
end;

procedure TForm1.BtAtualizarClick(Sender: TObject);
begin
 webBrowser1.Navigate(Edit1.Text);
end;

procedure TForm1.BtVoltarClick(Sender: TObject);
begin
 {o bloco Try-Except evita que aparea mensagem de
   erro caso no haja nenhum site anterior ao qual voltar
   }
 try
  WebBrowser1.GoBack ;
 except
 end;

end;

procedure TForm1.BtAvancarClick(Sender: TObject);
begin
 {o bloco Try-Except evita que aparea mensagem de
   erro caso no haja nenhum site posterior para
   o qual avanar
   }
 try
  WebBrowser1.GoForward ;
 except
 end;
  
end;

procedure TForm1.BtHomeClick(Sender: TObject);
begin
 WebBrowser1.GoHome;
 Edit1.Text := WebBrowser1.LocationURL; 
end;

procedure TForm1.WebBrowser1DownloadComplete(Sender: TObject);
begin
 StatusBar1.SimpleText := 'Concludo';
end;

procedure TForm1.menuAbrirClick(Sender: TObject);
begin
 if OpenDialog1.Execute then
  WebBrowser1.Navigate(OpenDialog1.FileName);
end;

procedure TForm1.BtAbrirClick(Sender: TObject);
begin
 menuAbrirClick (self);
end;

procedure TForm1.menuSairClick(Sender: TObject);
begin
 if application.MessageBox('Tem certeza de que deseja sair?',pchar(application.title),36)=IDYES then
  Close ;
end;

procedure TForm1.menuImprimirClick(Sender: TObject);
var
 Valor1, Valor2: OleVariant;
begin
 WebBrowser1.ControlInterface.ExecWB(OLECMDID_PRINT, OLECMDEXECOPT_PROMPTUSER, Valor1, Valor2) ;
end;

procedure TForm1.BtImprimirClick(Sender: TObject);
begin
 menuImprimirClick (self);
end;

procedure TForm1.menuSalvarComoClick(Sender: TObject);
var
  PersistStream: IPersistStreamInit;
  Stream: IStream;
  FileStream: TFileStream;
begin
  if not Assigned(WebBrowser1.Document) then
  begin
    application.messagebox('Documento HTML no carregado','Documento Web',16);
    Exit;
  end;

  if SaveDialog1.Execute then begin//begin do savedialog
   PersistStream := WebBrowser1.Document as IPersistStreamInit;
   FileStream := TFileStream.Create(SaveDialog1.FileName, fmCreate);
    try
     Stream := TStreamAdapter.Create(FileStream, soReference) as IStream;
     if Failed(PersistStream.Save(Stream, True)) then
       application.messageBox('Falha ao salvar arquivo HTML!','Salvar arquivo',16);
    finally
     FileStream.Free;
    end;
  end;//end do savedialog

end;

procedure TForm1.BtSalvarComoClick(Sender: TObject);
begin
 menuSalvarComoClick(self);
end;

end.
